unit Unit1;
//             
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MMSystem, ExtCtrls, UnitDFT, TeEngine, Series, TeeProcs, Chart,
  ComCtrls;

  const
    discret = 20000;  // per second

  type

  TData16 = array [0..BufSize-1] of smallint;
  PData16 = ^TData16;

  TForm1 = class(TForm)
    Image1: TImage;
    ChartSpectr: TChart;
    StatusBar1: TStatusBar;
    Splitter1: TSplitter;
    Series1: TFastLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  public
    procedure OnWaveIn(var Msg: TMessage); message MM_WIM_DATA;
    procedure WCard;
    procedure DrawSignal(GraphBuf: array of smallint);
    procedure SetParam;
    procedure CreateSpectr;
    procedure CreateSpectr_Const;
  end;

var
  Form1: TForm1;
  WaveIn: hWaveIn;
  hBuf: THandle;
  BufHead: TWaveHdr;

  Bits16: boolean;
  Stop: boolean;
  AllData: Longint;
  DFT:TDFT;
  ScaleX:real;
  tt1,tt2,tt3,tt4:longint;
  period_capture:word;


implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  AllData := 0;
  Form1.Caption:='Sound-Agent';
  Form1.DoubleBuffered := True;
  Width:=1008;

  Image1.Picture.Bitmap.Width := Image1.width;
  Image1.Picture.Bitmap.Height:= Image1.height;
  with Image1.Picture.Bitmap.Canvas do begin
    Pen.Style   := psSolid;
    Pen.Color   := clRed;
    Brush.Style := bsSolid;
    Brush.Color := 0;
    FillRect(Rect(0, 0, Image1.Width, Image1.Height));
    FillRect(ClientRect);
  end;

  DFT := TDFT.Create;

  SetParam;
  ChartSpectr.TopAxis.Maximum:=DFT.kmax;
  ChartSpectr.TopAxis.Minimum:=0;
  ChartSpectr.BottomAxis.Maximum:=DFT.kmax * ScaleX;
  ChartSpectr.BottomAxis.Minimum:=0;

  tt1:=0;
  tt2:=0;
  tt3:=0;
  tt4:=0;
  WCard;
end;

procedure TForm1.SetParam;
var k,n:integer;
    pr:integer;
    S:integer;
begin

 S:=Sizeof(pr);
 ScaleX:=discret;
 for k:=0 to DFT.kmax-1 do
  for n:=0 to DFT.nmax-1 do
   begin
    DFT.nkT:=n*k*DFT.T;
    pr:=round(sin(DFT.nkT)*DFT.ADC);
    DFT.sin_nmax.WriteBuffer(pr,S);
    pr:=round(cos(DFT.nkT)*DFT.ADC);
    DFT.cos_nmax.WriteBuffer(pr,S);
   end;
 DFT.Create_SinCos;  

end;

procedure TForm1.CreateSpectr;
var
 k:word;
 Re,Im,Ampl:real;
 F:integer;
 st:string;
 pr:real;
begin

 for k:=0 to DFT.kmax-1 do
 begin
   Re:=DFT.ReDFTQ(k);
   Im:=DFT.ImDFTQ(k);
   Ampl:=Sqrt(Re*Re+Im*Im);
   pr:=k*ScaleX/DFT.nmax;

   if k=0 then Ampl:=0;

   st:=format('%0.0f',[pr]);
   ChartSpectr.Series[0].AddXY(k,Ampl,st);

 end;

end;
procedure TForm1.CreateSpectr_Const;
var
 k:word;
 Re,Im,Ampl:real;
 F:integer;
 st:string;
 pr:real;
begin

 for k:=0 to DFT_kmax-1 do
 begin
   Re:=DFT.ReDFTQ_Const(k);
   Im:=DFT.ImDFTQ_Const(k);
   Ampl:=Sqrt(Re*Re+Im*Im);
   pr:=k*ScaleX/DFT_nmax;

   if k=0 then Ampl:=0;

   st:=format('%0.0f',[pr]);
   ChartSpectr.Series[0].AddXY(k,Ampl,st);

 end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //   ,  
  WCard;
//  FreeAndNil(DFT.sin_nmax);
//  FreeAndNil(DFT.cos_nmax);
end;

procedure TForm1.WCard;
var
  header: TWaveFormatEx;
  BufLen: word;
  buf: pointer;
begin
  Stop := not Stop;
  if Stop then begin

    bits16 := True;   //  false  8 

    with header do begin
      wFormatTag := WAVE_FORMAT_PCM;
      nChannels := 1;
      nSamplesPerSec := discret;
      wBitsPerSample := integer(Bits16) * 8 + 8;
//       
      nBlockAlign := nChannels * (wBitsPerSample div 8);
//       
      nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
//      
      cbSize := 0;
    end;

    WaveInOpen(Addr(WaveIn), WAVE_MAPPER, addr(header), Handle, 0, CALLBACK_WINDOW);
    BufLen := header.nBlockAlign * BufSize;
    hBuf := GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, BufLen);
    Buf := GlobalLock(hBuf);

    with BufHead do begin
      lpData := Buf;
      dwBufferLength := BufLen;
      dwFlags:= WHDR_BEGINLOOP
    end;

    WaveInPrepareHeader(WaveIn, Addr(BufHead), sizeof(BufHead));
    WaveInAddBuffer(WaveIn, addr(BufHead), sizeof(BufHead));
    WaveInStart(WaveIn);
  end
  else begin
    WaveInReset(WaveIn);
    WaveInUnPrepareHeader(WaveIn, addr(BufHead), sizeof(BufHead));
    WaveInClose(WaveIn);
    GlobalUnlock(hBuf);
    GlobalFree(hBuf);
  end;
end;

procedure TForm1.OnWaveIn;
var
  i: integer;
  tmpBuf: array of smallint;
  data16: PData16;
begin

  tt1:=gettickcount;
  period_capture:=abs(tt2-tt1);
  tt2:=tt1;
  if Bits16 then
  begin
    data16 := PData16(PWaveHdr(Msg.lParam)^.lpData);

    SetLength(tmpBuf, BufSize);
    for i := 0 to Length(tmpBuf) - 1 do tmpBuf[i] := data16^[i];


    ChartSpectr.Series[0].Clear;
    tt3:=gettickcount;
    DrawSignal(tmpBuf);
    StatusBar1.Panels[1].Text:=inttostr(abs(gettickcount-tt3));
    tt3:=gettickcount;
    CreateSpectr_Const;
    StatusBar1.Panels[2].Text:=inttostr(abs(gettickcount-tt3));
    StatusBar1.Panels[0].Text:='Period: '+inttostr(period_capture);
  end;

  if Stop then WaveInAddBuffer(WaveIn, PWaveHdr(Msg.lParam),SizeOf(TWaveHdr))
  else Stop:= True;
  Update;
end;

procedure TForm1.DrawSignal(GraphBuf: array of smallint);
var i, tmpX, tmpY,pr: integer;
begin
  Image1.Refresh;

  with Image1.Picture.Bitmap.Canvas do begin
    Pen.Color   := clgreen;
    Brush.Color := 0;
    Rectangle(0, 0, Image1.Width, Image1.Height);
  end;

  Image1.Picture.Bitmap.Canvas.MoveTo(0, Image1.Height);
  for i:=0 to Length(GraphBuf) - 1 do begin

//    pr:= round(40*sin(i/8))+100;
//    GraphBuf[i]:=pr;

    tmpX := Round(i*Image1.Width/Length(GraphBuf));
//    tmpY := (Image1.Height * GraphBuf[i]) div 65536 + (Image1.Height div 2);
    tmpY := (Image1.Height * GraphBuf[i]) div 32768 + (Image1.Height div 2);

    Image1.Picture.Bitmap.Canvas.LineTo(tmpX, tmpY);
    DFT.fdata[i]:=GraphBuf[i];
  end;
end;

end.
